#ifndef DIM
#error DIM unset
#endif

#include <dune/common/function.hh>

#include <dune/tnnmg/problem-classes/convexproblem.hh>

#include <dune/tectonic/globalfriction.hh>
#include <dune/tectonic/myblockproblem.hh>

#include "explicitgrid.hh"
#include "explicitvectors.hh"

#include "solverfactory.hh"
#include "state/stateupdater.hh"
#include "timestepping.hh"

using Function = Dune::VirtualFunction<double, double>;
using Factory = SolverFactory<
    DIM, MyBlockProblem<ConvexProblem<GlobalFriction<Matrix, Vector>, Matrix>>,
    Grid>;
using MyStateUpdater = StateUpdater<ScalarVector, Vector>;
using MyVelocityUpdater = TimeSteppingScheme<Vector, Matrix, Function, DIM>;

template class FixedPointIterator<Factory, MyStateUpdater, MyVelocityUpdater>;
